#include <windows.h>
#include <stdio.h>
#include <commctrl.h>
#include <math.h>
#include <dshow.h>
#include <qedit.h>
#include "resource.h"

#pragma comment(lib,"strmiids.lib")
#pragma comment(lib,"comctl32.lib")

#define MYWNDTITLE		"MediaCutter"
#define MYWNDCLASS		"CLASS_MediaCutter"
#define RELEASE(p)		if (p){p->Release();p=NULL;}
#define MAX_VENC		64			// 񋓂rfIRvbT̍ő吔
#define MAX_LEN			64			// th̍ő啶
#define WM_GRAPHNOTIFY	WM_USER + 1

HINSTANCE		g_hInst;
HWND			g_hDlg = NULL;
HWND			g_hPic = NULL;
HWND			g_hSlider = NULL;
HWND			g_hBttn[8];
HICON			g_hIcon[5];
IAMTimeline		*g_pTL  = NULL;
IRenderEngine	*g_pRE = NULL;
IGraphBuilder	*g_pGB = NULL;
IVideoWindow	*g_pVW = NULL;
IMediaControl	*g_pMC = NULL;
IMediaEventEx	*g_pME = NULL;
IMediaSeeking	*g_pMS = NULL;
IVideoFrameStep	*g_pVFS = NULL;
IBaseFilter		*g_pVEnc[MAX_VENC];

UINT			g_venc_ct = 0;	// 񋓂ꂽrfIRvbT̐
UINT			g_venc_idx = 0;	// IꂽrfIRvbT̔ԍ
bool			g_bAudioOnly = FALSE;	// yt@C?
REFERENCE_TIME	g_rtTotal = 0;			// ǂݍ񂾃t@C̒ (100 imbP)
bool			g_bSeek1 = FALSE;		// V[No[ꂽH
long			g_ct = 0;					// Xg[̐
char			g_loadname[MAX_PATH] = "";	// ǂݍ݃t@C
char			g_savename[MAX_PATH] = "";	// ۑt@C
char			g_title[256] = "";			// ^Cg
char			g_venc_name[MAX_VENC][MAX_LEN];	// rfIRvbT̃th
REFERENCE_TIME	g_start = 0,g_end = 0;		// ۑJnEIʒu

typedef struct{
	AM_MEDIA_TYPE	amt;		// tH[}bg
	double			rate;		// t[[gifpsj
}MEDIA_INFO,*LPMEDIA_INFO;

MEDIA_INFO	g_MI[2];			// Xg[

BOOL	CALLBACK ProcDlg1(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL	CALLBACK ProcDlg2(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
void	M_Play();
void	M_Stop();
void	M_Rewind();
void	M_Step();
void	M_StartPos();
void	M_EndPos();
void	Set_Slider_Pos();
void	Set_Seek();
void	Set_IconPlay();
int		Get_State();
bool	Render_Settings();
bool	Get_MediaInfo(char *filename);
bool	Init_TimeLine();
bool	GroupToTL(int index);
bool	Run_FilterGraphTL();
bool	Save_AviFile();
bool	Save_WavFile();
bool	Enum_Filters(REFCLSID clsid);
void	Load(char *filename);
void	Open_FileDlg();
void	Save_FileDlg();
void	Set_EnableWindows(bool bFlag);
void	Cleanup();

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	MSG		msg;
	
	g_hInst = hInst;
	g_hDlg = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DIALOG1), NULL, ProcDlg1);
	ShowWindow(g_hDlg, nCmdShow);
	
	while(GetMessage(&msg, NULL, 0, 0)) {
		if (IsDialogMessage(g_hDlg, &msg)) continue;
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain

// _CAOvV[W
BOOL CALLBACK ProcDlg1(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		if(FAILED(CoInitialize(NULL))){
			MessageBox(hDlg,"COM ̏Ɏs܂",MYWNDTITLE,MB_OK);
			SendMessage(hDlg,WM_CLOSE,0,0);
			return 0;
		}
		InitCommonControls();
		g_hPic     = GetDlgItem(hDlg, IDC_PIC1);
		g_hSlider  = GetDlgItem(hDlg, IDC_SLIDER1);
		g_hBttn[0] = GetDlgItem(hDlg, IDC_BUTTON1);
		g_hBttn[1] = GetDlgItem(hDlg, IDC_BUTTON2);
		g_hBttn[2] = GetDlgItem(hDlg, IDC_BUTTON3);
		g_hBttn[3] = GetDlgItem(hDlg, IDC_BUTTON4);
		g_hBttn[4] = GetDlgItem(hDlg, IDC_BUTTON5);
		g_hBttn[5] = GetDlgItem(hDlg, IDC_BUTTON6);
		g_hBttn[6] = GetDlgItem(hDlg, IDC_BUTTON7);
		g_hBttn[7] = GetDlgItem(hDlg, IDC_BUTTON8);
		g_hIcon[0] = LoadIcon(g_hInst,MAKEINTRESOURCE(IDI_PLAY));
		g_hIcon[1] = LoadIcon(g_hInst,MAKEINTRESOURCE(IDI_PAUSE));
		g_hIcon[2] = LoadIcon(g_hInst,MAKEINTRESOURCE(IDI_STOP));
		g_hIcon[3] = LoadIcon(g_hInst,MAKEINTRESOURCE(IDI_REWIND));
		g_hIcon[4] = LoadIcon(g_hInst,MAKEINTRESOURCE(IDI_SLOW));
		SendMessage(g_hBttn[0],BM_SETIMAGE,IMAGE_ICON,(LPARAM)g_hIcon[0]);
		SendMessage(g_hBttn[1],BM_SETIMAGE,IMAGE_ICON,(LPARAM)g_hIcon[2]);
		SendMessage(g_hBttn[2],BM_SETIMAGE,IMAGE_ICON,(LPARAM)g_hIcon[3]);
		SendMessage(g_hBttn[3],BM_SETIMAGE,IMAGE_ICON,(LPARAM)g_hIcon[4]);
		Set_EnableWindows(FALSE);
		// rfIRvbT̗
		if(!Enum_Filters(CLSID_VideoCompressorCategory)){
			MessageBox(hDlg,"rfIRvbT񋓂ł܂",MYWNDTITLE,MB_OK);
			SendMessage(hDlg,WM_CLOSE,0,0);
			return 0;
		}
		break;
		
	case WM_SHOWWINDOW:
		if(__argc > 1){
			Load(__argv[1]);
			__argc = 0;
		}
		break;
		
	case WM_DROPFILES:
		char	fname[MAX_PATH];
		HDROP	hDrop;
		
		hDrop = (HDROP) wParam;
		DragQueryFile(hDrop, 0, fname, sizeof(fname));
		Load(fname);
		DragFinish(hDrop);
		break;
		
	case WM_TIMER:
		Set_Slider_Pos();
		break;
		
	case WM_GRAPHNOTIFY:
		long evCode, param1, param2;
		if(!g_pME)	break;
		while(SUCCEEDED(g_pME->GetEvent(&evCode, &param1, &param2, 0)))
		{
			g_pME->FreeEventParams(evCode, param1, param2);
			if(evCode == EC_COMPLETE){
				if(g_pMC){
					KillTimer(hDlg, 1);
					g_pMC->StopWhenReady();
					M_Rewind();
					Set_IconPlay();
				}
				break;
			}
		}
		break;
		
	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case IDM_OPEN:		// J
			Open_FileDlg();
			break;
		case IDM_EXIT:		// I
			SendMessage(hDlg,WM_CLOSE,0,0);
			break;
		case IDC_BUTTON1:	// Đ / ꎞ~
			M_Play();
			break;
		case IDC_BUTTON2:	// ~
			M_Stop();
			break;
		case IDC_BUTTON3:	// ߂
			M_Rewind();
			if(Get_State() >= 2){
				g_pMC->StopWhenReady();
			}
			break;
		case IDC_BUTTON4:	// R}
			M_Step();
			break;
		case IDC_BUTTON5:	// Jnʒu
			M_StartPos();
			break;
		case IDC_BUTTON6:	// Iʒu
			M_EndPos();
			break;
		case IDC_BUTTON7:	// ۑJn
			Save_FileDlg();
			break;
		case IDC_BUTTON8:	// I
			SendMessage(hDlg,WM_CLOSE,0,0);
			break;
		default:
			return FALSE;
		}
		break;
		
	case WM_CLOSE:
		int i;
		for(i=0;i<MAX_VENC;i++){
			RELEASE(g_pVEnc[i]);
		}
		Cleanup();
		DestroyWindow(hDlg);
		CoUninitialize();
		PostQuitMessage(0);
		break;
	
	default:
		if(uMsg == WM_HSCROLL){
			if(LOWORD(wParam) == TB_THUMBTRACK){
				g_bSeek1 = TRUE;
			}
			if(LOWORD(wParam) != TB_THUMBTRACK){
				Set_Seek();
			}
			break;
		}
		else{
			g_bSeek1 = FALSE;
		}
		return FALSE;
	}
	return TRUE;
}// ProcDlg1

// ۑ_CAOvV[W
BOOL CALLBACK ProcDlg2(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		UINT	i;
		for(i=0;i<g_venc_ct;i++){
			SendDlgItemMessage(hDlg,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) g_venc_name[i]);
		}
		SendDlgItemMessage(hDlg,IDC_COMBO1,CB_SETCURSEL,g_venc_idx,0);
		break;
		
	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case IDOK:
			g_venc_idx = SendDlgItemMessage(hDlg,IDC_COMBO1,CB_GETCURSEL,0,0);
			EndDialog (hDlg,TRUE);
			break;
		case IDCANCEL:
			EndDialog (hDlg,FALSE);
			break;
		}
		return FALSE;
		
	default:
		return FALSE;
	}
	return TRUE;
}// ProcDlg2

void M_Play()
{
	switch (Get_State())
	{
	case 1:
		KillTimer(g_hDlg, 1);
		g_pMC->Pause();
		Set_IconPlay();
		break;
	case 2:
	case 3:
		SetTimer(g_hDlg, 1, 100, NULL);
		g_pMC->Run();
		HICON hIcon = (HICON)SendMessage(g_hBttn[0],BM_SETIMAGE,IMAGE_ICON,(LPARAM)g_hIcon[1]);
		DeleteObject(hIcon);
		break;
	}
}// M_Play

void M_Stop()
{
	if(g_pMC){
		KillTimer(g_hDlg, 1);
		M_Rewind();
		g_pMC->StopWhenReady();
		Set_IconPlay();
	}
}// M_Stop

void M_Rewind()
{
	if(g_pMS){
		REFERENCE_TIME rtNow,startpos;
		g_pMS->GetCurrentPosition(&rtNow);
		if(rtNow <= g_start){
			startpos = 0;
		}
		else{
			startpos = g_start;
		}
		g_pMS->SetPositions((LONGLONG*)&startpos, AM_SEEKING_AbsolutePositioning, NULL, AM_SEEKING_NoPositioning);
		Set_Slider_Pos();
	}
}// M_Rewind

void M_Step()
{
	if(g_pVFS){
		if(SUCCEEDED(g_pVFS->CanStep(0, NULL))){
			KillTimer(g_hDlg, 1);
			g_pVFS->Step(1, NULL);
			Set_Slider_Pos();
			Set_IconPlay();
		}
	}
}// M_Step

void M_StartPos()
{
	if(g_pMS && g_pMC){
		REFERENCE_TIME rtNow;
		g_pMS->GetCurrentPosition(&rtNow);
		g_start = rtNow;
		SendMessage(g_hSlider,TBM_SETSELSTART,TRUE,(LPARAM)(rtNow*1000/g_rtTotal));
		g_pMS->SetPositions((LONGLONG*)&g_start, AM_SEEKING_AbsolutePositioning, NULL, AM_SEEKING_NoPositioning);
		if(g_end <= g_start){
			g_end = g_start;
			g_pMS->SetPositions(NULL, AM_SEEKING_NoPositioning, (LONGLONG*)&g_end, AM_SEEKING_AbsolutePositioning);
		}
		
	}
}// M_StartPos

void M_EndPos()
{
	if(g_pMS && g_pMC){
		REFERENCE_TIME rtNow;
		g_pMS->GetCurrentPosition(&rtNow);
		g_end = rtNow;
		SendMessage(g_hSlider,TBM_SETSELEND,TRUE,(LPARAM)(rtNow*1000/g_rtTotal));
		g_pMS->SetPositions(NULL, AM_SEEKING_NoPositioning, (LONGLONG*)&g_end, AM_SEEKING_AbsolutePositioning);
		if(g_start >= g_end){
			g_start = g_end;
			g_pMS->SetPositions((LONGLONG*)&g_start, AM_SEEKING_AbsolutePositioning, NULL, AM_SEEKING_NoPositioning);
		}
	}
}// M_EndPos

void Set_Slider_Pos()
{
	if(g_pMS && g_pMC && !g_bSeek1){
		LONGLONG rtNow;
		g_pMS->GetCurrentPosition(&rtNow);
		SendMessage(g_hSlider,TBM_SETPOS,TRUE,(LPARAM)(rtNow*1000/g_rtTotal));
	}
}// Set_Slider_Pos

void Set_Seek()
{
	if(g_pMC && g_pMS){
		LONGLONG	pos = SendMessage(g_hSlider,TBM_GETPOS,0,0);
		pos = pos * g_rtTotal / 1000;
		g_pMS->SetPositions(&pos, AM_SEEKING_AbsolutePositioning, NULL, AM_SEEKING_NoPositioning);
		if(Get_State() >= 2){
			g_pMC->StopWhenReady();
		}
	}
}// Set_Seek

void Set_IconPlay()
{
	HICON hIcon;
	hIcon = (HICON)SendMessage(g_hBttn[0],BM_GETIMAGE,IMAGE_ICON,0);
	if(hIcon != g_hIcon[0]){
		hIcon = (HICON)SendMessage(g_hBttn[0],BM_SETIMAGE,IMAGE_ICON,(LPARAM)g_hIcon[0]);
		DeleteObject(hIcon);
	}
}// Set_IconPlay

// 0:擾s 1:Run, 2:Pause, 3:Stop
int Get_State()
{
	if(g_pMC){
		OAFilterState fs;
		g_pMC->GetState(0, &fs);
		switch(fs)
		{
		case State_Running:
			return 1;
		case State_Paused:
			return 2;
		case State_Stopped:
			return 3;
		}
	}
	return 0;
}// Get_State

// Đ̐ݒ
bool Render_Settings()
{
	if(!strcmp(g_loadname, "")){
		MessageBox(g_hDlg,"t@C܂",MYWNDTITLE,MB_OK);
		return TRUE;
	}
	
	HRESULT hr;
	SetCursor(LoadCursor(NULL,IDC_WAIT));
	RELEASE(g_pGB);
	hr = CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER,
						  IID_IGraphBuilder, (void **)&g_pGB);
	if(FAILED(hr)){
		return FALSE;
	}
	WCHAR	wFname[MAX_PATH];
	MultiByteToWideChar(CP_ACP,0,g_loadname,-1,wFname,sizeof(wFname));
	if(FAILED(g_pGB->RenderFile(wFname, NULL))){
		return FALSE;
	}
	RELEASE(g_pVW);
	if(FAILED(g_pGB->QueryInterface(IID_IVideoWindow, (void **)&g_pVW))){
		return FALSE;
	}
	if(FAILED(g_pVW->put_MessageDrain((OAHWND)g_hDlg))){
		g_bAudioOnly = TRUE;
		RELEASE(g_pVW);
	}
	else{
		g_bAudioOnly = FALSE;
	}
	if(!g_bAudioOnly){
		if(FAILED(g_pVW->put_Owner((OAHWND)g_hPic))){
			RELEASE(g_pVW);
			return FALSE;
		}
		if(FAILED(g_pVW->put_WindowStyle(WS_CHILD | WS_CLIPSIBLINGS))){
			RELEASE(g_pVW);
			return FALSE;
		}
		long		v_wdh,v_hgt;
		IBasicVideo	*pBV;
		if(FAILED(g_pGB->QueryInterface(IID_IBasicVideo, (void**)&pBV))){
			RELEASE(g_pVW);
			return FALSE;
		}
		pBV->GetVideoSize(&v_wdh, &v_hgt);
		RELEASE(pBV);
		RECT	rc;
		int		wdh,hgt;
		GetClientRect(g_hPic,&rc);
		if ((float)v_wdh / rc.right > (float)v_hgt / rc.bottom){
			wdh = rc.right - 2;
			hgt = v_hgt * rc.right / v_wdh - 2;
		}
		else{
			wdh = v_wdh * rc.bottom / v_hgt - 2;
			hgt = rc.bottom - 2;
		}
		g_pVW->SetWindowPosition((rc.right-wdh)/2, (rc.bottom-hgt)/2, wdh, hgt);
	}
	RELEASE(g_pMS);
	if(FAILED(g_pGB->QueryInterface(IID_IMediaSeeking, (void**)&g_pMS))){
		return FALSE;
	}
	if(FAILED(g_pMS->GetDuration(&g_rtTotal))){
		return FALSE;
	}
	if(!g_rtTotal){
		return FALSE;
	}
	RELEASE(g_pME);
	if(FAILED(g_pGB->QueryInterface(IID_IMediaEventEx, (void**)&g_pME))){
		return FALSE;
	}
	if(FAILED(g_pME->SetNotifyWindow((OAHWND)g_hDlg, WM_GRAPHNOTIFY, 0))){
		return FALSE;
	}
	RELEASE(g_pMC);
	if(FAILED(g_pGB->QueryInterface(IID_IMediaControl, (void**)&g_pMC))){
		return FALSE;
	}
	RELEASE(g_pVFS);
	if(FAILED(g_pGB->QueryInterface(IID_IVideoFrameStep, (void**)&g_pVFS))){
		return FALSE;
	}
	g_start = 0;
	g_end   = g_rtTotal;
	SendMessage(g_hSlider,TBM_SETTICFREQ,250,0);
	SendMessage(g_hSlider,TBM_SETRANGEMIN,TRUE,0);
	SendMessage(g_hSlider,TBM_SETRANGEMAX,TRUE,1000);
	SendMessage(g_hSlider,TBM_SETSELSTART,TRUE,0);
	SendMessage(g_hSlider,TBM_SETSELEND,TRUE,1000);
	if(g_pMC){
		g_pMC->Pause();
	}
	SetCursor(NULL);
	return TRUE;
}// Render_Settings

// fBȀ擾
bool Get_MediaInfo(char *filename)
{
	HRESULT		hr;
	IMediaDet	*pMD  = NULL;
	hr = CoCreateInstance(CLSID_MediaDet, NULL, CLSCTX_INPROC_SERVER, 
							IID_IMediaDet, (void**)&pMD);
	if(FAILED(hr)){
		return FALSE;
	}
	WCHAR	wFname[MAX_PATH];
	MultiByteToWideChar(CP_ACP,0,filename,-1,wFname,sizeof(wFname));
	if(FAILED(pMD->put_Filename(wFname))){
		RELEASE(pMD);
		return FALSE;
	}
	if(FAILED(pMD->get_OutputStreams(&g_ct))){
		RELEASE(pMD);
		return FALSE;
	}
	if(g_ct <= 0){
		RELEASE(pMD);
		return FALSE;
	}
	if(g_ct > 2){
		g_ct = 2;
	}
	for(long i=0;i<g_ct;i++){
		if(SUCCEEDED(pMD->put_CurrentStream(i))){
			pMD->get_FrameRate(&g_MI[i].rate);
			ZeroMemory(&g_MI[i].amt, sizeof(AM_MEDIA_TYPE));
			pMD->get_StreamMediaType(&g_MI[i].amt);
		}
	}
	RELEASE(pMD);
	return TRUE;
}// Get_MediaInfo

// ^CC̏
bool Init_TimeLine()
{
	if(!strcmp(g_loadname, "")){
		return TRUE;
	}
	
	HRESULT		hr;
	// ^CC쐬
	RELEASE(g_pTL);
	hr = CoCreateInstance(CLSID_AMTimeline, NULL, CLSCTX_INPROC_SERVER, 
							IID_IAMTimeline, (void**)&g_pTL);
	if(FAILED(hr)){
		return FALSE;
	}
	Get_MediaInfo(g_loadname);	// t@C擾
	g_start -= g_start % 10000000;
	for(long i=0;i<g_ct;i++){
		GroupToTL(i);			// O[v^CCɒǉ
	}
	// ^CC̕ۑ
	if(!Run_FilterGraphTL()){
		return FALSE;
	}
	return TRUE;
}// Init_TimeLine

// O[v쐬āA^CCɒǉ
bool GroupToTL(int index)
{
	// O[v쐬āA^CCɒǉ
	IAMTimelineGroup	*pGp    = NULL;
	IAMTimelineObj		*pGpObj = NULL;
	if(FAILED(g_pTL->CreateEmptyNode(&pGpObj, TIMELINE_MAJOR_TYPE_GROUP))){
		return FALSE;
	}
	if(FAILED(pGpObj->QueryInterface(IID_IAMTimelineGroup, (void **)&pGp))){
		RELEASE(pGpObj);
		return FALSE;
	}
	if(g_MI[index].rate > 0){
		if(FAILED(pGp->SetOutputFPS(g_MI[index].rate))){
			RELEASE(pGpObj);
			return FALSE;
		}
	}
	AM_MEDIA_TYPE mtGp;
	ZeroMemory(&mtGp, sizeof(AM_MEDIA_TYPE));
	mtGp.majortype = g_MI[index].amt.majortype;
	if(mtGp.majortype == MEDIATYPE_Audio){
		mtGp.subtype     = g_MI[index].amt.subtype;
		mtGp.formattype  = FORMAT_WaveFormatEx;
		mtGp.cbFormat    = sizeof(WAVEFORMATEX);
		mtGp.pbFormat    = (BYTE*)CoTaskMemAlloc(mtGp.cbFormat);
		if(mtGp.pbFormat == NULL){
			CoTaskMemFree(mtGp.pbFormat);
			RELEASE(pGp);
			RELEASE(pGpObj);
			return FALSE;
		}
		memcpy(mtGp.pbFormat, g_MI[index].amt.pbFormat, mtGp.cbFormat);
		if(FAILED(pGp->SetMediaType(&mtGp))){
			CoTaskMemFree(mtGp.pbFormat);
			RELEASE(pGp);
			RELEASE(pGpObj);
			return FALSE;
		}
		CoTaskMemFree(mtGp.pbFormat);
	}
	else if(mtGp.majortype == MEDIATYPE_Video){
		mtGp.subtype     = g_MI[index].amt.subtype;
		mtGp.formattype  = FORMAT_VideoInfo;
		mtGp.cbFormat    = sizeof(VIDEOINFOHEADER);
		mtGp.pbFormat    = (BYTE*)CoTaskMemAlloc(mtGp.cbFormat);
		if(mtGp.pbFormat == NULL){
			CoTaskMemFree(mtGp.pbFormat);
			RELEASE(pGp);
			RELEASE(pGpObj);
			return FALSE;
		}
		memcpy(mtGp.pbFormat, g_MI[index].amt.pbFormat, mtGp.cbFormat);
		VIDEOINFOHEADER *pVH = (VIDEOINFOHEADER*) mtGp.pbFormat;
		mtGp.bFixedSizeSamples = TRUE;
		mtGp.lSampleSize = DIBSIZE(pVH->bmiHeader);
		if(FAILED(pGp->SetMediaType(&mtGp))){
			CoTaskMemFree(mtGp.pbFormat);
			RELEASE(pGp);
			RELEASE(pGpObj);
			return FALSE;
		}
		CoTaskMemFree(mtGp.pbFormat);
	}
	if(FAILED(g_pTL->AddGroup(pGpObj))){
		RELEASE(pGp);
		RELEASE(pGpObj);
		return FALSE;
	}
	RELEASE(pGpObj);
	// gbN쐬āAO[vɒǉ
	IAMTimelineObj		*pTkObj = NULL;
	IAMTimelineTrack	*pTk = NULL;
	IAMTimelineComp 	*pCp = NULL;
	if(FAILED(g_pTL->CreateEmptyNode(&pTkObj, TIMELINE_MAJOR_TYPE_TRACK))){
		RELEASE(pGp);
		return FALSE;
	}
	if(FAILED(pGp->QueryInterface(IID_IAMTimelineComp, (void **)&pCp))){
		RELEASE(pTkObj);
		RELEASE(pGp);
		return FALSE;
	}
	if(FAILED(pCp->VTrackInsBefore(pTkObj, 0))){	// Dx̍łႢC[쐬
		RELEASE(pCp);
		RELEASE(pTkObj);
		RELEASE(pGp);
		return FALSE;
	}
	if(FAILED(pTkObj->QueryInterface(IID_IAMTimelineTrack, (void **)&pTk))){
		RELEASE(pCp);
		RELEASE(pTkObj);
		RELEASE(pGp);
		return FALSE;
	}
	RELEASE(pCp);
	RELEASE(pTkObj);
	RELEASE(pGp);
	// \[X쐬āAgbNɒǉ
	IAMTimelineSrc	*pSrc = NULL;
	IAMTimelineObj	*pSrcObj = NULL;
	if(FAILED(g_pTL->CreateEmptyNode(&pSrcObj, TIMELINE_MAJOR_TYPE_SOURCE))){
		RELEASE(pTk);
		return FALSE;
	}
	if(FAILED(pSrcObj->QueryInterface(IID_IAMTimelineSrc, (void **)&pSrc))){
		RELEASE(pSrcObj);
		RELEASE(pTk);
		return FALSE;
	}
	if(FAILED(pSrcObj->SetStartStop(0, g_end - g_start))){
		RELEASE(pSrc);
		RELEASE(pSrcObj);
		RELEASE(pTk);
		return FALSE;
	}
	WCHAR	wFname[MAX_PATH];
	MultiByteToWideChar(CP_ACP,0,g_loadname,-1,wFname,sizeof(wFname));
	if(FAILED(pSrc->SetMediaName(wFname))){
		RELEASE(pSrc);
		RELEASE(pSrcObj);
		RELEASE(pTk);
		return FALSE;
	}
	if(FAILED(pSrc->SetMediaTimes(g_start, g_end))){
		RELEASE(pSrc);
		RELEASE(pSrcObj);
		RELEASE(pTk);
		return FALSE;
	}
	if(FAILED(pTk->SrcAdd(pSrcObj))){
		RELEASE(pSrc);
		RELEASE(pSrcObj);
		RELEASE(pTk);
		return FALSE;
	}
	RELEASE(pSrc);
	RELEASE(pSrcObj);
	RELEASE(pTk);
	return TRUE;
}// GroupToTL

// ^CC̕ۑ
bool Run_FilterGraphTL()
{
	HRESULT	hr;
	RELEASE(g_pRE);
	hr = CoCreateInstance(CLSID_RenderEngine, NULL, CLSCTX_INPROC_SERVER,
							IID_IRenderEngine, (void**) &g_pRE);
	if(FAILED(hr)){
		return FALSE;
	}
	if(FAILED(g_pRE->SetTimelineObject(g_pTL))){
		return FALSE;
	}
	if(FAILED(g_pRE->ConnectFrontEnd())){
		return FALSE;
	}
	if(FAILED(g_pRE->GetFilterGraph(&g_pGB))){
		return FALSE;
	}
	if(g_bAudioOnly){
		if(!Save_WavFile()){
			return FALSE;
		}
	}
	else{
		if(!Save_AviFile()){
			return FALSE;
		}
	}
	// s
	RELEASE(g_pMC);
	if(FAILED(g_pGB->QueryInterface(IID_IMediaControl, (void **)&g_pMC))){
		return FALSE;
	}
	RELEASE(g_pME);
	if(FAILED(g_pGB->QueryInterface(IID_IMediaEvent, (void **)&g_pME))){
		return FALSE;
	}
	SendMessage(g_hSlider,TBM_CLEARSEL,FALSE,0);
	SendMessage(g_hSlider,TBM_SETRANGE,TRUE,MAKELONG(0,0));
	if(FAILED(g_pMC->Run())){
		return FALSE;
	}
	SendMessage(g_hDlg,WM_SETTEXT,0,(LPARAM)"ۑ EEE");
	// I܂őҋ@
	Set_EnableWindows(FALSE);
	EnableWindow(g_hBttn[7], FALSE);
	SetCursor(LoadCursor(NULL,IDC_WAIT));
	long	evCode;
	if(FAILED(g_pME->WaitForCompletion(INFINITE, &evCode))){
		SetCursor(NULL);
		return FALSE;
	}
	if(g_pMC){
		g_pMC->Stop();
	}
	if(g_pRE){
		g_pRE->ScrapIt();
	}
	Cleanup();
	SendMessage(g_hDlg,WM_SETTEXT,0,(LPARAM)g_title);
	Set_EnableWindows(TRUE);
	EnableWindow(g_hBttn[7], TRUE);
	SetCursor(NULL);
	return TRUE;
}// Run_FilterGraphTL

// AVIt@Cɕۑݒ
bool Save_AviFile()
{
	HRESULT	hr;
	ICaptureGraphBuilder2	*pCGB = NULL;
	hr = CoCreateInstance(CLSID_CaptureGraphBuilder2, NULL, CLSCTX_INPROC_SERVER, 
						  IID_ICaptureGraphBuilder2, (void **)&pCGB);
	if(FAILED(hr)){
		return FALSE;
	}
	if(FAILED(pCGB->SetFiltergraph(g_pGB))){
		RELEASE(pCGB);
		return FALSE;
	}
	// rfIRvbT̒ǉ
	if(g_pVEnc[g_venc_idx]){
		if(FAILED(g_pGB->AddFilter(g_pVEnc[g_venc_idx], L"Video Compressor"))){
			RELEASE(pCGB);
			return FALSE;
		}
	}
	// ۑt@C̎wAviMux擾ătB^Otɒǉ
	WCHAR	wFname[MAX_PATH];
	MultiByteToWideChar(CP_ACP,0,g_savename,-1,wFname,sizeof(wFname));
	IBaseFilter	*pMux = NULL;
	hr = pCGB->SetOutputFileName(&MEDIASUBTYPE_Avi, wFname, &pMux, NULL);
	if(FAILED(hr)){
		RELEASE(pCGB);
		return FALSE;
	}
	// s̐ڑ
	long NumGroups;
	g_pTL->GetGroupCount(&NumGroups);
	for (int i=0;i<NumGroups;i++){
		IPin *pPin;
		if(g_pRE->GetGroupOutputPin(i, &pPin) == S_OK){
			hr = pCGB->RenderStream(NULL, &MEDIATYPE_Video, pPin, g_pVEnc[g_venc_idx], pMux);
			hr = pCGB->RenderStream(NULL, &MEDIATYPE_Audio, pPin, NULL, pMux);
			RELEASE(pPin);
		}
	}
	RELEASE(pMux);
	RELEASE(pCGB);
	return TRUE;
}// Save_AviFile

// WAVt@Cɕۑ
//@DXSDK\Samples\C++\DirectShow\BaseClassesrhA
//@DXSDK\Samples\C++\DirectShow\Filters\WavDestrh
//@wavdest.ax 쐬B
//	炩߁Awavdest.ax  C:\\Windows\\System ɃRs[A
//	[X^[g][t@Cw肵Ďs]ŁA
//	Regsvr32 wavdest.ax Ɠ͂[OK]NbNKvB
bool Save_WavFile()
{
	static const GUID CLSID_WavDest =
	{ 0x3c78b8e2, 0x6c4d, 0x11d1, { 0xad, 0xe2, 0x0, 0x0, 0xf8, 0x75, 0x4b, 0x99 } };
	HRESULT 	hr;
	IBaseFilter	*pMux = NULL;
	hr = CoCreateInstance(CLSID_WavDest, NULL, CLSCTX_INPROC_SERVER, 
						  IID_IBaseFilter, (void **)&pMux);
	if(FAILED(hr)){
		return FALSE;
	}
	if(FAILED(g_pGB->AddFilter(pMux, L"WavDest"))){
		RELEASE(pMux);
		return FALSE;
	}
	IFileSinkFilter2	*pFS = NULL;
	hr = CoCreateInstance(CLSID_FileWriter, NULL, CLSCTX_INPROC_SERVER,
						  IID_IFileSinkFilter2, (void **)&pFS);
	if(FAILED(hr)){
		RELEASE(pMux);
		return FALSE;
	}
	pFS->SetMode(AM_FILE_OVERWRITE);
	IBaseFilter		*pFW = NULL;
	if(FAILED(pFS->QueryInterface(IID_IBaseFilter, (void **)&pFW))){
		RELEASE(pFS);
		RELEASE(pMux);
		return FALSE;
	}
	if(FAILED(g_pGB->AddFilter((IBaseFilter *)pFW, L"FileWriter"))){
		RELEASE(pFS);
		RELEASE(pMux);
		return FALSE;
	}
	WCHAR	wFname[MAX_PATH];
	MultiByteToWideChar(CP_ACP,0,g_savename,-1,wFname,sizeof(wFname));
	if(FAILED(pFS->SetFileName(wFname, NULL))){
		RELEASE(pFW);
		RELEASE(pFS);
		RELEASE(pMux);
		return FALSE;
	}
	ICaptureGraphBuilder2	*pCGB = NULL;
	hr = CoCreateInstance(CLSID_CaptureGraphBuilder2, NULL, CLSCTX_INPROC_SERVER, 
						  IID_ICaptureGraphBuilder2, (void **)&pCGB);
	if(FAILED(hr)){
		return FALSE;
	}
	if(FAILED(pCGB->SetFiltergraph(g_pGB))){
		RELEASE(pCGB);
		return FALSE;
	}
	// s̐ڑ
	long NumGroups;
	g_pTL->GetGroupCount(&NumGroups);
	for (int i=0;i<NumGroups;i++){
		IPin *pPin;
		if(g_pRE->GetGroupOutputPin(i, &pPin) == S_OK){
			// \[XtB^WavDestt@CC^ڑ
			hr = pCGB->RenderStream(NULL, NULL, pPin, pMux, pFW);
			RELEASE(pPin);
		}
	}
	if(FAILED(hr)){
		RELEASE(pFW);
		RELEASE(pFS);
		RELEASE(pMux);
		RELEASE(pCGB);
		return FALSE;
	}
	RELEASE(pFW);
	RELEASE(pFS);
	RELEASE(pMux);
	RELEASE(pCGB);
	return TRUE;
}// Save_WavFile

// w肳ꂽJeS̃tB^tB^Otɒǉ
// clsid  :[IN]  tB^񋓂JeSCLSID
bool Enum_Filters(REFCLSID clsid)
{
	HRESULT			hr;
	ICreateDevEnum	*pEnum = NULL;
	IEnumMoniker	*pEm = NULL;
	IMoniker		*pM = NULL;
	ULONG			cFetched;
	char			buf[MAX_LEN];
	
	hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC_SERVER,
							IID_ICreateDevEnum, (void**)&pEnum);
	if(FAILED(hr)){
		return FALSE;
	}
	hr = pEnum->CreateClassEnumerator(clsid, &pEm, 0);
	if(FAILED(hr)){
		RELEASE(pEnum);
		return FALSE;
	}
	RELEASE(pEnum);
	for(int i=0;i<MAX_VENC;i++){
		RELEASE(g_pVEnc[i]);
	}
	g_pVEnc[0] = NULL;
	strcpy(g_venc_name[0], "none");
	g_venc_ct = 1;
	pEm->Reset();
	while(S_OK == pEm->Next(1, &pM, &cFetched))
	{
		IPropertyBag *pBag;
		hr = pM->BindToStorage(0, 0, IID_IPropertyBag, (void **)&pBag);
		if(SUCCEEDED(hr))
		{
			VARIANT var;
			var.vt = VT_BSTR;
			hr = pBag->Read(L"FriendlyName", &var, NULL);
			if(SUCCEEDED(hr))
			{
				WideCharToMultiByte(CP_ACP, 0, var.bstrVal, -1, buf, sizeof(buf), NULL, NULL);
				if(strcmp(buf, "")){
					if(SUCCEEDED(pM->BindToObject(NULL, NULL, IID_IBaseFilter, (void**)&g_pVEnc[g_venc_ct]))){
						if(!strncmp(buf, "Indeo", 5)){
							g_venc_idx = g_venc_ct;
						}
						strncpy(g_venc_name[g_venc_ct], buf, MAX_LEN);
						g_venc_ct ++;
						if(g_venc_ct >= MAX_VENC){
							break;
						}
					}
				}
				SysFreeString(var.bstrVal);
			}
			RELEASE(pBag);
		}
		RELEASE(pM);
	}
	RELEASE(pEm);
	if(!g_venc_ct){
		return FALSE;
	}
	return TRUE;
}// Enum_Filters

void Load(char *filename)
{
	char *p;
	p = strrchr(filename, '.');
	if(stricmp(p+1, "avi") && stricmp(p+1, "wav")){
		MessageBox(g_hDlg,"AVI,WAVt@CȊO͑ΉĂ܂",MYWNDTITLE,MB_OK);
		return;
	}
	strncpy(g_loadname, filename, sizeof(g_loadname));
	Cleanup();
	if(!Render_Settings()){
		Cleanup();
		MessageBox(g_hDlg,"ǂݍ߂܂",MYWNDTITLE,MB_OK);
		return;
	}
	Set_EnableWindows(TRUE);
	p = strrchr(filename, '\\');
	sprintf(g_title,"%s  <%s>",p+1,MYWNDTITLE);
	SendMessage(g_hDlg,WM_SETTEXT,0,(LPARAM)g_title);
}// Load

// I[vt@C_CAO
void Open_FileDlg()
{
	OPENFILENAME	ofn;
	char			fn[MAX_PATH] = "";
	
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = g_hDlg;
	ofn.Flags = OFN_PATHMUSTEXIST | 
				OFN_FILEMUSTEXIST | 
				OFN_HIDEREADONLY; 
	ofn.lpstrFile = fn;
	ofn.nMaxFile = sizeof(fn);
	ofn.lpstrFilter = "ި̧ (*.wav; *.avi)\0*.wav;*.avi\0"
					  "AVI̧ (*.avi)\0" "*.avi\0" 
					  "WAV̧ (*.wav)\0" "*.wav\0";
	ofn.nFilterIndex = 1;
	if(GetOpenFileName(&ofn)){
		Load(fn);
	}
}// Open_FileDlg

// ۑt@C_CAO
void Save_FileDlg()
{
	OPENFILENAME	ofn;
	char			fn[MAX_PATH] = "";
	
	ZeroMemory(&ofn, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = g_hDlg;
	ofn.Flags = OFN_OVERWRITEPROMPT;
	ofn.lpstrFile = fn;
	ofn.nMaxFile = sizeof(fn);
	if(g_bAudioOnly){
		ofn.lpstrFilter = "̧ (*.wav)\0*.wav\0";
	}
	else{
		ofn.lpstrFilter = "AVI̧ (*.avi)\0*.avi\0";
	}
	ofn.nFilterIndex = 1;
	if(GetSaveFileName(&ofn)){
		strncpy(g_savename, fn, sizeof(g_savename));
		if(!stricmp(g_savename, g_loadname)){
			MessageBox(g_hDlg,"ǂݍ݃t@Cɂ͕ۑł܂",MYWNDTITLE,MB_OK);
		}
		else{
			if(!strrchr(g_savename, '.')){
				if(g_bAudioOnly)
					strcat(g_savename,".wav");
				else
					strcat(g_savename,".avi");
			}
			Cleanup();
			if(g_bAudioOnly){
				if(!Init_TimeLine()){
					Cleanup();
					MessageBox(g_hDlg,"ۑł܂",MYWNDTITLE,MB_OK);
				}
				Render_Settings();
			}
			else{
				BOOL flag;
				flag = DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_DIALOG2), g_hDlg, ProcDlg2);
				if(flag){
					if(!Init_TimeLine()){
						Cleanup();
						MessageBox(g_hDlg,"ۑł܂",MYWNDTITLE,MB_OK);
					}
					Render_Settings();
				}
			}
		}
	}
}// Save_FileDlg

void Set_EnableWindows(bool bFlag)
{
	EnableWindow(g_hPic, bFlag);
	EnableWindow(g_hSlider, bFlag);
	for(int i=0;i<7;i++){
		EnableWindow(g_hBttn[i], bFlag);
	}
}// Set_EnableWindows

// IuWFNg̉
void Cleanup()
{
	KillTimer(g_hDlg, 1);
	if(g_pMC){
		g_pMC->Stop();
	}
	SendMessage(g_hSlider,TBM_SETPOS,TRUE,0);
	if(g_pVW){
		g_pVW->put_Visible(OAFALSE);
		g_pVW->put_Owner(NULL);
	}
	for(int i=0;i<2;i++){
		CoTaskMemFree(g_MI[i].amt.pbFormat);
	}
	RELEASE(g_pVW);
	RELEASE(g_pMS);
	RELEASE(g_pME);
	RELEASE(g_pMC);
	RELEASE(g_pVFS);
	RELEASE(g_pGB);
	RELEASE(g_pRE);
	RELEASE(g_pTL);
}// Cleanup
